image: docker:latest
services:
  - docker:18-dind

stages:
  - dev
  - stage
  - deploy

variables:
  RELEASE_IMAGE:  registry.gitlab.com/devnotes.it/react/nextjs-notes-app:latest
  STAGE_IMAGE:  registry.gitlab.com/devnotes.it/react/nextjs-notes-app:stage
  DEV_IMAGE:  registry.gitlab.com/devnotes.it/react/nextjs-notes-app:$CI_COMMIT_REF_NAME


build_dev:
  stage: dev
  tags:
    - docker
  script:
    - docker login -u gitlab-ci-token -p $CI_JOB_TOKEN $CI_REGISTRY
    - docker build -t $DEV_IMAGE .
    - docker push $DEV_IMAGE

build_stage:
  stage: stage
  tags:
    - docker
  script:
    - docker login -u gitlab-ci-token -p $CI_JOB_TOKEN $CI_REGISTRY
    - docker build -t $STAGE_IMAGE .
    - docker push $STAGE_IMAGE
  only:
    - development


integration_tests:
  stage: stage
  script:
    - echo "Testing app"
    - echo "Force to fail"
    - exit 1
  only:
    - development


build_prod:
  stage: deploy
  tags:
    - docker
  script:
    - docker login -u gitlab-ci-token -p $CI_JOB_TOKEN $CI_REGISTRY
    - docker build -t $RELEASE_IMAGE .
    - docker push $RELEASE_IMAGE
  only:
    - master
    - merge_request

